//==============================================================
// Simple MEMO   (STPP.05)
//     for PSP CFW3.80 M33-5
// STEAR 2009
//--------------------------------------------------------------
// Simple IMEɂ{eLXgGfB^B
//--------------------------------------------------------------

#include <stdio.h>
#include <pspuser.h>
#include <pspctrl.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <string.h>
#include <malloc.h>

#include "zenkaku.h"
#include "draw.h"
#include "sime.h"

//----- }N -----


//----- 萔ݒ -----

#define	LINELEN		79											// R[ḧs̒
#define	RECODEMAX	30000										// R[h̍ő吔is̍őj
#define	TBY			24											// eLXg̈̊JnYW
#define	SLINE		19											// ʂɕ\łs
#define	SWIDTH		79											// ʂɕ\ł

//----- vg^Cv錾 -----


//- VXe֘A -

int		SetupCallbacks(void);
int		callbackThread(SceSize args, void *argp);
int		exitCallback(int arg1, int arg2, void *common);

//- ̑ -


//------ O[oϐ -----

static unsigned int __attribute__((aligned(16))) gList[1000];
static volatile int	gExitRequest = 0;

static char	gTextFile[129] = {"main.c"};						// Ăt@C
static long gSCor[] = {											// VXe֘A̔zF
				0xFFFFFF,										// F
				0x80A080,										// ʒm_CAOigj
				0x407040,										// ʒm_CAOij
				0x8080A0,										// x_CAOigj
				0x404070,										// x_CAOij
			};
static long	gCor[] = {
				0x804040,										// ^Cg
//				0x40A040,										// ^Cg
				0xFFFFFF,										// ^CgF
				0x000000,										// wiF
				0xFFFFFF,										// F
//				0x804040,										// XN[o[igj
//				0x502020,										// XN[o[ij
//				0xFFB0B0,										// NX[o[io[j
				0x40A040,										// XN[o[igj
				0x306030,										// XN[o[ij
				0xA0F0A0,										// NX[o[io[j
				0x707070,										// ^u
				0x80FF80,										// s
				0x80FF80,										// [EOF]
				0x80FFFF										// ̑̃Rg[R[h
			};
static int	gSave,												// t@CύXĂ邩i0:Noj
			gCRLF,												// sR[hi0:LF 1:CRLFj
			gTab = 0,											// ^ui0:4 ȊO:8j
			gLineMax;											// Ŝ̍s

static struct {
	long	chainBack;											// Xg`FCiÕR[hj
																//     0xFFFFFFFFȂ疢gpR[hA0xFFFFFFFEȂ擪s
	long	chainNext;											// Xg`FCĩR[hj
																//     0xFFFFFFFFȂŏIs
	int		flag;												// ÕR[hƂ̊֌W
																//     b0:1 ÕR[h瑱Ă
																//     b1:1 ̃R[hɑĂ
																//     b2:1 sR[h
	int		len;												// {̒
	char	text[LINELEN+1];									// {
} gText[RECODEMAX];												// sǗiʏ̈s̃R[hɑΉj

//------ s[hw -----

#ifndef	PSP_MODULE_KERNEL
#define	PSP_MODULE_KERNEL	0x1000
#endif
#ifndef	PSP_MODULE_USER
#define	PSP_MODULE_USER		0
#endif

PSP_MODULE_INFO("SimpleMEMO", PSP_MODULE_USER, 1, 1);
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);
PSP_MAIN_THREAD_STACK_SIZE_KB(32);


//==============================================================
// ^Cg
//--------------------------------------------------------------

void DrawTitle(void)
{
	char	str[129];

	strcpy(str,gTextFile);
	if (gSave)
		strcat(str," (XV)");
	CurveBox(0, 0, 480, 21, 3, gCor[0], gCor[0]);
	mh_print(6, 1, str, gCor[1]);
	Fill(475, 14, 5, 8, gCor[0]);
	HLine(0, 22, 475, gCor[3]);
}

//==============================================================
// Xe[^X\
//--------------------------------------------------------------
// flag 1:[[
//--------------------------------------------------------------

void DrawSts(int x,int y,int pline,int linemax,int flag)
{
	static int	bx;
	int			i,wy;
	long		no,pos,line;

	no = 0;
	pos = 0;
	line = 0;
	while (no<y){												// s_s֕ϊ
		if (gText[pos].flag & 0x04) line++;
		no++;
		pos = gText[pos].chainNext;
		if (pos==0xFFFFFFFF) break;
	}
	Fill(420, 1, 30, 12, gCor[0]);
	DrawVal(420, 1, line+1, 0, 1, gCor[1]);						// _sʒu
	mh_print(450, 1, ":", gCor[1]);
	Fill(456, 1, 12, 12, gCor[0]);
	DrawVal(456, 1, x+1, -1, 1, gCor[1]);						// ʒu

	if (flag){													// [[
		Fill(0, 14, 475, 11, gCor[2]);
		HLine(0, 22, 475, gCor[3]);
		for (i=0; i<79 ;i++){
			wy = 2;
			if (i%8==1) wy = 1;
			if (i%4==0) wy += 2;
			if (i%8==0){
				wy += 3;
				DrawVal(i*6+2, 15, i, -1, 0, gCor[3]);
			}
			VLine(i*6, 22-wy, wy, gCor[3]);
		}
	} else {
		XFill(1+bx*6, 14, 5, 8, gCor[1]);						// J[\ʒuij
	}
	XFill(1+x*6, 14, 5, 8, gCor[1]);							// J[\ʒui\j
	bx = x;
	VRollBar(475, 22, 272-22, pline, SLINE,linemax, 0, gCor[4],gCor[5],gCor[6]);
}

//==============================================================
// G[_CAO
//--------------------------------------------------------------

void DiaError(int x,char *msg)
{
	SceCtrlData		pad;

	DiaBox1(x, 50, msg, gSCor[0], gSCor[3], gSCor[4]);
	while(SIMEgetchar(pad)==0 && !gExitRequest){	// ܂őҋ@
		sceCtrlReadBufferPositive(&pad, 1);
		sceDisplayWaitVblankStart();
	}
}

//==============================================================
// f[^R[h
//--------------------------------------------------------------

void InitRec(void)
{
	long	i;

	for (i=0; i<RECODEMAX ;i++){
		gText[i].chainBack=0xFFFFFFFF;
		gText[i].chainNext=0xFFFFFFFF;
		gText[i].flag = 0;
		gText[i].len = 0;
	}
	gLineMax = 0;
	gSave = 0;
}

//==============================================================
// t@Cǂݍ
//--------------------------------------------------------------
// ߂l 0: ȊO:s
//--------------------------------------------------------------

int fileload(char *fname)
{
	char	*data,msg[128],c;
	int		fd,cnt,len;
	long	filesize,pos;

	//----- f[^R[h -----

	InitRec();

	//----- t@Cǂݍ -----

	msg[0] = '\0';
	fd = sceIoOpen(fname, PSP_O_RDONLY, 0777);
	if (fd>=0){
		filesize = sceIoLseek(fd, 0, SEEK_END);
		sceIoLseek(fd, 0, SEEK_SET);
		data = (char*) malloc(filesize);
		if (data==NULL){										// mۂłȂ
			strcpy(msg,"mۂł܂ł");
		} else {
			sceIoRead(fd, data, filesize);
		}
	} else {
		strcpy(msg,"w肳ꂽt@C̓ǂݍ݂Ɏs܂");
	}

	if (msg[0]){												// G[
		DiaError(160,msg);
		return (-1);
	}

	//----- R[hPʂɕ -----

	pos = 0;
	cnt = 0;
	len = 0;
	gCRLF = 0;
	gText[gLineMax].chainBack = 0xFFFFFFFE;						// 擪s
	while (filesize>pos){
		c = data[pos++];
		if (c=='\r'){											// CR͎̂Ă
			gCRLF = 1;
		} else if (c=='\n'){
			gText[gLineMax].len = cnt+1;
			gText[gLineMax].text[cnt] = '\n';
			cnt = 0;
			len = 0;
			gText[gLineMax].chainNext = gLineMax+1;
			gText[gLineMax].flag |= 4;							// s
			gLineMax++;
			gText[gLineMax].chainBack = gLineMax-1;
		} else {
			if (chkSJIS(c)){									// Spꍇ
				if (len>=LINELEN-1){							// sɎ܂Ȃ
					gText[gLineMax].len = cnt;
					cnt = 0;
					len = 0;
					gText[gLineMax].chainNext = gLineMax+1;
					gText[gLineMax].flag |= 2;					// ̍sɑĂ
					gLineMax++;
					gText[gLineMax].chainBack = gLineMax-1;
					gText[gLineMax].flag |= 1;					// O̍s瑱Ă
				}
				gText[gLineMax].text[cnt++] = c;
				len++;
				c = data[pos++];
			}
			gText[gLineMax].text[cnt++] = c;
			if (c=='\t'){										// ^u
				if (gTab){
					len = (len + 8) & 0xF8;						// TAB=8
				} else {
					len = (len + 4) & 0xFC;						// TAB=4
				}
			} else {
				len++;
			}
			if (len>=LINELEN){
				gText[gLineMax].len = cnt;
				cnt = 0;
				len = 0;
				gText[gLineMax].chainNext = gLineMax+1;
				gText[gLineMax].flag |= 2;						// ̍sɑĂ
				gLineMax++;
				gText[gLineMax].chainBack = gLineMax-1;
				gText[gLineMax].flag |= 1;						// O̍s瑱Ă
			}
		}
	}

	//----- n -----

	free(data);
	return (0);
}

//==============================================================
// w蕨sɑΉ郌R[h擾
//--------------------------------------------------------------

long GetRNo(long line)
{
	long	no,rno;

	no = 0;
	rno = 0;
	while (no!=line){											// Xg`FCHȂsJEg
		if (gText[rno].chainNext==0xFFFFFFFF) break;
		rno = gText[rno].chainNext;
		no++;
	}
	return (rno);
}

//==============================================================
// R[heʂɕ\
//--------------------------------------------------------------

void DrawRecLine(int y,long rno)
{
	char	c[3] = {0,0,0};
	int		x,pos;

	pos = 0;
	x = 0;
	while (1){
		if (gText[rno].len){
			c[0] = gText[rno].text[pos++];
			if (c[0]=='\t'){									// ^u
				DrawChar(1+x*6, TBY+y*13+3, 0, gCor[7]);
				if (gTab){
					x = (x + 8) & 0xF8;							// TAB=8
				} else {
					x = (x + 4) & 0xFC;							// TAB=4
				}
			} else if (c[0]=='\n'){								// s
				if (x<SWIDTH) DrawChar(1+x*6, TBY+y*13+3, 1, gCor[8]);
			} else if (c[0]==0x1A){								// EOFi\Ȃj
			} else if ((unsigned char)c[0]<32){					// ̑̃Rg[R[h𔭌
				Fill(1+x*6, TBY+y*13, 5, 12, gCor[10]);
				x++;
			} else if (chkSJIS(c[0])){							// Sp
				c[1] = gText[rno].text[pos++];
				mh_print(1+x*6, TBY+y*13, c, gCor[3]);
				c[1] = '\0';
				x += 2;
			} else {											// p
				mh_print(1+x*6, TBY+y*13, c, gCor[3]);
				x++;
			}
		}
		if (gText[rno].len<=pos || pos>SWIDTH){					// \I
			if (gText[rno].chainNext==0xFFFFFFFF)
				mh_print(1+x*6, TBY+y*13, "[EOF]", gCor[9]);
			break;
		}
	}
}

//==============================================================
// wʒũR[heʂɕ\
//--------------------------------------------------------------

void DrawRec(long pline,int y)
{
	long	rno;

	rno = GetRNo(pline+y);										// wsɑΉĂ郌R[hT
	Fill(0, TBY+y*13, 475, 13, gCor[2]);
	DrawRecLine(y,rno);
}

//==============================================================
// ʑŜ̃R[he\
//--------------------------------------------------------------

void DrawFullRec(long pline)
{
	int		i;
	long	rno;

	rno = GetRNo(pline);										// wsɑΉĂ郌R[hT
	Fill(0, TBY, 475, 272-TBY, gCor[2]);
	for (i=0; i<SLINE ;i++){
		if (i+pline>gLineMax) break;
		DrawRecLine(i,rno);
		rno = gText[rno].chainNext;
	}
}

//==============================================================
// XN[Abv
//--------------------------------------------------------------
// ws牺XN[AbvB
// GUɏĂ܂B
// ͂̂܂ܑfɏĂ܂B
//--------------------------------------------------------------

void RollUp(int y)
{
	sceGuStart(GU_DIRECT,gList);
	sceGuCopyImage(GU_PSM_8888, 0,TBY+y*13+13,475,(SLINE-1-y)*13,512,VRAM, 0,TBY+y*13,512,VRAM);
	sceGuTexSync();
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// XN[_E
//--------------------------------------------------------------
// ws牺XN[_EB
// GUɏĂ܂B
// ꔭœ]ɂ͉]ȂƂȂ̂AȎw͂łȂ
// ۂ̂ŁAxʊOɓ]ĂړIʒuɕ`߂Ă܂B
// XN[AbvQ{ׂ͂̕Ǒ̊łႢ͂ȂȂB
// GUI
//--------------------------------------------------------------

void RollDown(int y)
{
	sceGuStart(GU_DIRECT,gList);
	sceGuCopyImage(GU_PSM_8888, 0,TBY+y*13,475,(SLINE-1-y)*13,512,VRAM, 0,0,512,VRAM[285]);
	sceGuCopyImage(GU_PSM_8888, 0,0,475,(SLINE-1-y)*13,512,VRAM[285], 0,TBY+(y+1)*13,512,VRAM);
	sceGuTexSync();
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// w蕨ʒuzȂłƂ߂J[\ʒu
//--------------------------------------------------------------
// cx  J[\ʒu
// cxr _J[\ʒu
// cxb ڕWJ[\ʒu
// rno sR[h
//--------------------------------------------------------------
// cxbɍł߂ʒucx,cxrZbgB
// VtgJISł͑Sp𐳂邽߂ɂ͍sSpp`FbN
// Ă@܂B
//--------------------------------------------------------------

void CMSet(int *cx,int *cxr,int cxb,long rno)
{
	int		stepp,stepr;

	*cx = 0;
	*cxr = 0;
	while (1){
		if (chkSJIS(gText[rno].text[*cxr])){
			stepr = 2;
			stepp = 2;
		} else if (gText[rno].text[*cxr]=='\t'){
			stepr = 1;
			if (gTab){
				stepp = (((*cx) + 8) & 0xF8) - *cx;				// TAB=8
			} else {
				stepp = (((*cx) + 4) & 0xFC) - *cx;				// TAB=4
			}
		} else {
			stepr = 1;
			stepp = 1;
		}
		if ( ((*cx)+stepp>=cxb) || ((*cxr)+stepr>=gText[rno].len) ) break;
		(*cx) += stepp;
		(*cxr) += stepr;
	}
}

//==============================================================
// J[\Ɉړ
//--------------------------------------------------------------
// O̍sŁAcxb̕ʒuɂƂ߂ʒuɃJ[\ړB
// Kvɉĉʂ̃XN[sB
//--------------------------------------------------------------

void CMUp(int *cx,int *cxr,int *cxb,int *cy,long *pline,long *rno)
{
	if (gText[*rno].chainBack==0xFFFFFFFE) return;				// 擪sȂ牽Ȃ
	(*cy)--;
	if (*cy<0){													// J[\ʂ͂ݏoȂXN[
		*cy = 0;
		(*pline)--;
		RollDown(0);
		DrawRec(*pline,0);
	}
	*rno = gText[*rno].chainBack;
	CMSet(cx, cxr, (*cxb)+1, *rno);								// J[\ʒu̕␳
}

//==============================================================
// J[\Ɉړ
//--------------------------------------------------------------
// ̍sŁAcxb̕ʒuɂƂ߂ʒuɃJ[\ړB
// Kvɉĉʂ̃XN[sB
//--------------------------------------------------------------

void CMDown(int *cx,int *cxr,int *cxb,int *cy,long *pline,long *rno)
{
	if (gText[*rno].chainNext==0xFFFFFFFF){						// ŏIsȂ
		CMSet(cx, cxr, (*cxb)+1, *rno);							// J[\ʒu̕␳
		return;
	}
	(*cy)++;
	if (*cy>=SLINE){											// J[\ʂ͂ݏoȂXN[
		*cy = SLINE-1;
		(*pline)++;
		RollUp(0);
		DrawRec(*pline,SLINE-1);
	}
	*rno = gText[*rno].chainNext;								// ̍sɑΉĂ郌R[h
	CMSet(cx, cxr, (*cxb)+1, *rno);								// J[\ʒu̕␳
}

//==============================================================
// main
//--------------------------------------------------------------

int	main(int argc,char **argv)
{
	SceCtrlData		pad1,pad2;
	char			str[33],msg[128];
	int				x,y,cx,cxb,cxr,cy,len,ret;
	long			pline,rno,bak;

	SetupCallbacks();

	//----- GU -----

	sceGuInit();
	sceGuStart(GU_DIRECT, gList);
	sceGuDrawBuffer(GU_PSM_8888, SCRBUF0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, SCRBUF0, BUF_WIDTH);
	sceGuFinish();
	sceGuSync(0, 0);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);

	//----- SimpleIME -----

	DiaBox1(40, 20, "t@C[h", gSCor[0], gSCor[1], gSCor[2]);
	ret = InitSIME(0);									// ǂݍ݂Ɗe평iwi̎ȕ[hj
	switch(ret){
	case 1:
		strcpy(msg,"sȎt@CłB");
		break;
	case 2:
		strcpy(msg,"ȂĎǂ߂܂łB");
		break;
	case 3:
		strcpy(msg, "iSIME.DICjJ܂łB");
		break;
	}
	if (ret){											// G[Ă
		strcat(msg,"\nϊ@\\gpo܂B");
		DiaBox1(60, 40, msg, gSCor[0], gSCor[3], gSCor[4]);
		while(SIMEgetchar(pad1)==0 && !gExitRequest){	// ܂őҋ@
			sceCtrlReadBufferPositive(&pad1, 1);
			sceDisplayWaitVblankStart();
		}
	}

	//----- t@Cǂݍ -----

	fileload(gTextFile);

	//----- C -----

	cx = 0;
	cy = 0;														// J[\ʒu
	cxb = 0;													// J[\ʒuۑp
	cxr = 0;													// J[\̘_ʒu
	pline = 0;													// ʍŏ㕔̕s
	rno = GetRNo(pline+cy);										// J[\ʒuɑΉ郌R[h
	DrawTitle();
	DrawSts(cx, pline+cy, pline, gLineMax, 1);					// [[nƃXN[o[
	DrawFullRec(pline);											// ʑS

	x = 1;
	y = TBY;
	SIMEcursor(2,&x,&y);										// J[\̑傫ƍWϐ̎w
	while(!gExitRequest){
		sceCtrlReadBufferPositive(&pad1, 1);
		x = 1 + cx*6;
		y = TBY + cy*13;										// J[\Wݒ
		SIMEgets(str,pad1);										// ͕̎擾
		if (str[0]!=0){											// ͂
			if (str[0]<32U){									// Rg[R[hꍇ
				switch(str[0]){
				case SIME_KEY_LTRIGGER:							// [L]
					bak = pline;
					pline -= 10;
					if (pline<0) pline = 0;
					if (bak!=pline)
						DrawFullRec(pline);
					rno = GetRNo(pline+cy);
					CMSet(&cx, &cxr, cxb+1, rno);				// J[\ʒu̕␳
					break;
				case SIME_KEY_RTRIGGER:							// [R]
					bak = pline;
					pline += 10;
					if (pline+SLINE-1>gLineMax){
						pline = gLineMax - SLINE+1;
						if (pline<0) pline = 0;
					}
					if (bak!=pline)
						DrawFullRec(pline);
					rno = GetRNo(pline+cy);
					CMSet(&cx, &cxr, cxb+1, rno);				// J[\ʒu̕␳
					break;
				case SIME_KEY_CIRCLE:							// 
					cxb = 0;
					CMDown(&cx, &cxr, &cxb, &cy, &pline, &rno);
					break;
				case SIME_KEY_UP:								// 
					CMUp(&cx, &cxr, &cxb, &cy, &pline, &rno);
					break;
				case SIME_KEY_DOWN:								// 
					CMDown(&cx, &cxr, &cxb, &cy, &pline, &rno);
					break;
				case 0x08:										// [BS]
				case SIME_KEY_LEFT:								// 
					if (cx==0){
						cxb = 79;								// sڕW
						CMUp(&cx, &cxr, &cxb, &cy, &pline, &rno);
					} else {
						cxb = cx;
						CMSet(&cx, &cxr, cxb, rno);				// J[\ʒu̕␳
					}
					cxb = cx;
					break;
				case SIME_KEY_RIGHT:							// 
					if (chkSJIS(gText[rno].text[cxr])){
						cxr += 2;
						cx += 2;
					} else if (gText[rno].text[cxr]=='\t'){
						cxr++;
						if (gTab){
							cx = (cx + 8) & 0xF8;				// TAB=8
						} else {
							cx = (cx + 4) & 0xFC;				// TAB=4
						}
					} else {
						cxr++;
						cx++;
					}
					if (cxr>=gText[rno].len){					// s̍Ōz
						cxb = 0;
						CMDown(&cx, &cxr, &cxb, &cy, &pline, &rno);
					}
					cxb = cx;
					break;
				}
			} else {											// ꍇ
				len = strlen(str);								// JEg
				BoxClr(x, y, len*6 ,12);
				mh_print(x, y, str, 0xFFFFFF);
				cx += len;
				if (cx>78){
					cx = 0;
					cy++;
					if (cy>SLINE-1) cy = SLINE-1;
				}
			}
			DrawSts(cx, pline+cy, pline, gLineMax, 0);			// Xe[^XXV
		}
		pad2 = pad1;

		sceDisplayWaitVblankStart();
	}

	//----- I -----

	EndSIME();
	sceGuTerm();
 	sceKernelExitGame();
	return 0;
}


//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;
	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}
